import pyb
from pyb import Pin, ADC, Timer, ExtInt,I2C,SPI
from ssd1306 import SSD1306
import _thread
import time,onewire,ds18x20
from machine import Pin
import dht
from pyb import UART
import micropython

accel = pyb.Accel()
adc = ADC(Pin('PA0'))
p_out = Pin('PA8', Pin.OUT_PP)
p_out.low()
time.sleep(1)
p_out.high()
display = SSD1306(pinout={'sda': 'PB7','scl': 'PB6'},height=64,external_vcc=False)
ow=onewire.OneWire(Pin('PB0'))#创建onewire总线 引脚4（G4）
ds=ds18x20.DS18X20(ow)
dht = dht.DHT11(Pin("PB1"))

KEY1 = Pin('PB9', Pin.IN, Pin.PULL_UP)
KEY2 = Pin('PB8', Pin.IN, Pin.PULL_UP)
relay = Pin('PB10', Pin.OUT_PP)


buzzer = Pin('PA1') # X1 has TIM2, CH1
tim = Timer(2, freq=1000)
ch = tim.channel(2, Timer.PWM, pin=buzzer)
ch.pulse_width_percent(0)




def UART_ISR(t):
	u.write(u.read())


def test1():

	#print("key1&relay test1")
	pyb.LED(4).toggle()
	relay.high()
	time.sleep(0.5)
	relay.low()
	time.sleep(0.5)

def test2():
	pyb.LED(3).toggle()
	ch.pulse_width_percent(50)
	time.sleep(0.5)
	ch.pulse_width_percent(0)
	time.sleep(0.5)
	#print("key2&beep test2")


def sw_callback():
	pyb.LED(2).toggle()
	print("ButtonPressed")






def funcA(sec):
	time.sleep(sec)
	i2c = I2C(1, I2C.MASTER, baudrate=100000)
	print(i2c.scan())
	time.sleep_ms(50)
	i2c.mem_write('xy', 80, 0x10)
	time.sleep_ms(50)
	if i2c.mem_read(2, 80, 0x10)==b'xy':
		abc=1
	else:
		abc=0
	p_out = Pin('PB12', Pin.OUT_PP)
	p_out.low()
	spi = SPI(2, SPI.MASTER, baudrate=2000, polarity=0, phase=0,crc=0x7,bits=8,firstbit=SPI.MSB)
	spi.send(0x9f) #发送固定指令，读取指令
	data=spi.recv(2) #接收id号
	p_out.high()
	print (data)
	if data==b'\xef0':
		print("SPI FLASH OK")
		spiflashok=1
	else:
		print("SPI FLASH ERROR")
		spiflashok=0

	try:
		display.poweron()
		display.init_display()
		if abc==1:
			display.draw_text(1,49,'24C08 OK')
		else:
			display.draw_text(1,49,'24C08 ERROR')

		if spiflashok==1:
			display.draw_text(55,49,' 25x40 OK')
		else:
			display.draw_text(55,49,'25x40 ERROR')

		for x in range(1,48):
			display.set_pixel(x,11,True)
			display.set_pixel(x,46,True)
		for y in range(11,46):
			display.set_pixel(1, y,True)
			display.set_pixel(48, y,True)

		display.draw_text(90,13,'X')
		display.draw_text(90,25,'Y')
		display.draw_text(90,37,'Z')


		display.draw_text(82,1,'MMA7660')
		display.draw_text(1,1,'DHT11Tem')
		display.draw_text(1,13,'DHT11Hum')
		display.draw_text(1,25,'18b20Tem')
		display.draw_text(1,37,'ADCvol')
		#display.set_pixel(1,1,True)
		while True:
			#display.set_pixel(63 - accel.x(), 30 - accel.y(), True)
			display.draw_text(55,37,str(round(adc.read()/4096,1)*3.3))

			try:
				display.draw_text(105,13,str(accel.x()))
				display.draw_text(105,25,str(accel.y()))
				display.draw_text(105,37,str(accel.z()))
			except :
				display.draw_text(105,13,'NC')
				display.draw_text(105,25,'NC')
				display.draw_text(105,37,'NC')
			if KEY1.value()==0:
				test1()
			elif KEY2.value()==0:
				test2()
			else:
				pass
				#_thread.exit()

			try:
				roms = ds.scan()#扫描总线上的设备
				ds.convert_temp()#获取采样温度
				for rom in roms:
					tem1=ds.read_temp(rom)
					display.draw_text(55,25,str(round(tem1,1)))
			except :
					display.draw_text(55,25,'NC')
			try:
				dht.measure()
				#print("temperature:",dht.temperature())
				#print("humidity:",dht.humidity())
				display.draw_text(55,1,str(round(dht.temperature(),1)))
				display.draw_text(55,13,str(round(dht.humidity(),1)))
			except :
				pass

			display.display()
			time.sleep_ms(30)

	except Exception as ex:
		print('Unexpected error: {0}'.format(ex))
		#pyb.hard_reset()
		#display.poweroff()


if __name__ == '__main__':
	micropython.alloc_emergency_exception_buf(100)

	u = UART(2)
	u.init(9600)
	u.irq(trigger = UART.IRQ_RXIDLE, handler = UART_ISR)

	_thread.start_new_thread(funcA, (1,))






